/*
 * ********************************************************************************************************************
 *
 *                     :*$@@%$*:                         ;:                ;;    ;;
 *                   :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                  :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                  =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                  =@*                                  %!              @ $= % %@=   =%@!      %=
 *             *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *           %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *         ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *         $@*   ;@@@%=!:                *@*
 *         =@$    ;;;!=%@@@@=!           =@!
 *          %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *           ;%@@$=$@@%*       *@@@$=%@@%;
 *              ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.objects
import com.alibaba.fastjson.annotation.JSONField
import com.persagy.server.datacenter.models.entities.base.BaseInfo
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 项目信息实体类
 *
 * @author  张维新
 */
@ApiModel(description = "项目信息实体类")
@Table(name = "project")
open class Project : BaseInfo() {

    /** 项目ID */
    @ApiModelProperty(value = "项目ID",position = 1)
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 项目名称 */
    @ApiModelProperty(value = "项目名称",position = 2)
    @Column(name = "name")
    var name: String? = null

//    @ApiModelProperty(value = "项目名称",position = 3)
//    @Column(name = "password")
//    @JSONField(name = "PassWord")
//    var password: String? = null

    /** 项目本地编码 */
    @ApiModelProperty(value = "项目本地编码",position = 4)
    @Column(name = "local_id")
    var localId: String? = null

    /** 项目本地名称 */
    @ApiModelProperty(value = "项目本地名称",position = 5)
    @Column(name = "local_name")
    var localName: String? = null

    /** 项目介绍 */
    @ApiModelProperty(value = "项目介绍",position = 5)
    @Column(name = "introduction")
    var introduction: String? = null

    /** 商业层数 */
    @ApiModelProperty(value = "商业层数",position = 5)
    @Column(name = "business_floor_num")
    var businessFloorNum: String? = null

    /** 办公层数 */
    @ApiModelProperty(value = "办公层数",position = 5)
    @Column(name = "office_floor_num")
    var officeFloorNum: String? = null

    /** 地理位置 */
    @ApiModelProperty(value = "地理位置",position = 7)
    @Column(name = "geo_info")
    var geoInfo: HashMap<String,Any?>? = null

    /** 项目信息 */
    @ApiModelProperty(value = "项目信息",position = 8)
    @Column(name = "project_info")
    var projectInfo: HashMap<String,Any?>? = null

    /** 商业信息 */
    @ApiModelProperty(value = "商业信息")
    @Column(name = "commercial_info")
    var commercialInfo: HashMap<String,Any?>? = null

    /** 能源价格 */
    @ApiModelProperty(value = "能源价格")
    @Column(name = "energy_cost")
    var energyCost: HashMap<String,Any?>? = null

    /** 室外环境 */
    @ApiModelProperty(value = "室外环境")
    @Column(name = "outdoor_env")
    var outdoorEnv: HashMap<String,Any?>? = null

    /** 天气预报 */
    @ApiModelProperty(value = "天气预报")
    @Column(name = "weather")
    var weather: HashMap<String,Any?>? = null

    /** 能耗信息 */
    @ApiModelProperty(value = "能耗信息")
    @Column(name = "consumption_info")
    var consumptionInfo: HashMap<String,Any?>? = null

    /** 自定义 */
//    @ApiModelProperty(value = "自定义")
//    @Column(name = "custom_param")
//    @JSONField(name = "CustomParam")
//    var customParam: HashMap<String,Any?>? = null

    /** 对象类型 */
    @ApiModelProperty(value = "对象类型")
    @Column(name = "object_type")
    @JSONField(name = "ObjectType")
    override var objectType: String? = "Project"

    @ApiModelProperty(value = "信息点")
    @Column(name = "infos")
    var infos: HashMap<String,Any?>? = null




} // Class Project