package com.persagy.server.scanbuilding

import com.persagy.service.models.SBaseEntity
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 用户日志实体类
 *
 * @author 付国宝
 */
@ApiModel(description = "用户日志实体类")
@Table(name = "scanbuilding.user_log")
class UserLog : SBaseEntity() {

    /** 主键id */
    @ApiModelProperty(value = "主键id")
    @Id
    @Column(name = "id")
    var id:String? = null

    /** 项目ID */
    @ApiModelProperty(value = "项目ID")
    @Column(name = "project_id")
    var projectId:String? = null

    /** 扫楼用户ID */
    @ApiModelProperty(value = "扫楼用户ID")
    @Column(name = "user_id")
    var userId:String? = null

    /** 扫楼用户名字 */
    @ApiModelProperty(value = "扫楼用户名字")
    @Column(name = "name")
    var name:String? = null

    /** 扫楼用户手机 */
    @ApiModelProperty(value = "扫楼用户手机")
    @Column(name = "phone")
    var phone:String? = null

    /** 用户操作 */
    @ApiModelProperty(value = "用户操作")
    @Column(name = "action")
    var action:String? = null

    /** 操作对象id */
    @ApiModelProperty(value = "操作对象id")
    @Column(name = "object_id")
    var objectId:String? = null

    /** 备注 */
    @ApiModelProperty(value = "备注")
    @Column(name = "note")
    var note:String? = null

    @ApiModelProperty(value = "")
    var comming:String? = null

} // Class UserLog