package com.persagy.server.models

import com.alibaba.fastjson.annotation.JSONField
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import java.io.Serializable

/**
 * 信息点统计实体类
 *
 * @author 蒋湘江
 */
@ApiModel(description = "信息点统计实体类")
class InfoPoint : Serializable {

    /** 自定义信息点总数 */
    @ApiModelProperty(value = "自定义信息点总数")
    @JSONField(name = "CustomInfoPointCounts")
    var customInfoPointCounts:Int?=0

    /** 项目中设备用到的自定义信息点数 */
    @ApiModelProperty(value = "项目中设备用到的自定义信息点数")
    @JSONField(name = "CustomInfoPoint")
    var customInfoPoint:Int?=0

    /** 动态信息点总数 */
    @ApiModelProperty(value = "动态信息点总数")
    @JSONField(name = "DynamicInfoPointCounts")
    var dynamicInfoPointCounts:Int?=0

    /** 设备用到的动态信息点数 */
    @ApiModelProperty(value = "设备用到的动态信息点数")
    @JSONField(name = "DynamicInfoPoint")
    var dynamicInfoPoint:Int?=0

    /** 静态信息点总数 */
    @ApiModelProperty(value = "静态信息点总数")
    @JSONField(name = "StaticInfoPointCounts")
    var staticInfoPointCounts:Int?=0

    /** 设备用到的静态信息点数 */
    @ApiModelProperty(value = "设备用到的静态信息点数")
    @JSONField(name = "StaticInfoPoint")
    var staticInfoPoint:Int?=0

}// Class InfoPoint