/*
 * ********************************************************************************************************************
 *
 *                     :*$@@%$*:                         ;:                ;;    ;;
 *                   :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                  :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                  =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                  =@*                                  %!              @ $= % %@=   =%@!      %=
 *             *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *           %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *         ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *         $@*   ;@@@%=!:                *@*
 *         =@$    ;;;!=%@@@@=!           =@!
 *          %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *           ;%@@$=$@@%*       *@@@$=%@@%;
 *              ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.persagy.server.service.objects

import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.models.objects.FloorCompon
import com.persagy.server.service.base.Service
import com.persagy.service.SPageContext
import com.persagy.service.models.enums.SResponseType
import com.persagy.service.models.requests.SQueryRequest
import com.persagy.service.models.responses.SQueryResponse


/**
 * 楼层信息服务
 *
 * @author 张维新
 */
object FloorService : Service<FloorCompon>(SMybatisDao(FloorCompon::class.java)) {


    /**
     * 查询楼层信息 以及重复使用同一个模型文件楼层做标记
     *
     * @param   request     查询条件
     */
    fun queryFloor(request: SQueryRequest) : SQueryResponse<FloorCompon> {

        return try {
            val pageQuery = pageQuery(request, arrayListOf(SFilter.eq("projectId", SPageContext.getHeader("projectId").toString())))
            if (!pageQuery.content.isNullOrEmpty()){

                for (floor in pageQuery.content!!){

                    if (floor.outline == null&&!floor.modelId.isNullOrEmpty()){
//                        val floorList = select(SFilter.eq("projectId", SPageContext.getHeader("projectId").toString()),SFilter.not(SFilter.eq("FloorID", floor.id!!)),
//                                SFilter.isNull("Outline"), SFilter.eq("ModelId", floor.modelId!!)).exec()
                        val floorList = select(
                            SFilter.eq("projectId", SPageContext.getHeader("projectId").toString()),
                                 SFilter.eq("ModelId", floor.modelId!!)).exec()
                        if (floorList.size>1){
                            floor.sign = 1
                        }
                    }
                }
            }
            pageQuery
        } catch (e: Exception) {
            e.printStackTrace()
            SQueryResponse(SResponseType.failure, e.message.toString())
        }
    } // // Function queryFloor（）

} // Object FloorService