package com.persagy.server.meiku.models.entities

import com.persagy.service.models.SBaseEntity
import com.persagy.service.models.annotations.SCascade
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import java.io.Serializable
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 图库-美库
 * @author  wx
 * @date  2020/9/21 10:45
 */
@ApiModel(description = "锚点")
@Table(name = "labsl_meiku.meiku")
class MeiKu : Serializable, SBaseEntity() {

    /** 图id */
    @ApiModelProperty(value = "图id")
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 分类 */
    @ApiModelProperty(value = "分类")
    @Column(name = "category")
    var category: String? = null

    /** 品牌 */
    @ApiModelProperty(value = "品牌")
    @Column(name = "brand")
    var brand: String? = null

    /** 型号 */
    @ApiModelProperty(value = "型号")
    @Column(name = "specification")
    var specification: String? = null

    /** 锚点列表 */
    @ApiModelProperty(value = "锚点列表")
    @SCascade(table="labsl_meiku.meiku_anchor", idColumn="meitu_id", childIdColumn="id")
    var anchorList: ArrayList<MeiKuAnchor>? = null

    @ApiModelProperty(value = "状态")
    @SCascade(table="labsl_meiku.meiku_state", idColumn="meiku_id", childIdColumn="id")
    var state: ArrayList<MeiKuState>? = null

} // Class MeiKu